local addon = CreateFrame("Frame")
local epoch = 0

local LOOT_DELAY = 0.1

addon:RegisterEvent("LOOT_READY")
local f = CreateFrame("Frame")
f:SetScript("OnEvent", OnEvent);
f:RegisterEvent("MERCHANT_SHOW");
addon:SetScript("OnEvent", function ()
	if GetCVarBool("autoLootDefault") ~= IsModifiedClick("AUTOLOOTTOGGLE") then
		if (GetTime() - epoch) >= LOOT_DELAY then
			for i = GetNumLootItems(), 1, -1 do
				LootSlot(i)
			end
			epoch = GetTime()
		end
	end
end)




local function OnEvent(self, event)
	totalPrice = 0	
	for myBags = 0,4 do
		for bagSlots = 1, GetContainerNumSlots(myBags) do
			CurrentItemLink = GetContainerItemLink(myBags, bagSlots)
			if CurrentItemLink then
				_, _, itemRarity, _, _, _, _, _, _, _, itemSellPrice = GetItemInfo(CurrentItemLink)
				_, itemCount = GetContainerItemInfo(myBags, bagSlots)
				if itemRarity == 0 and itemSellPrice ~= 0 then
					totalPrice = totalPrice + (itemSellPrice * itemCount)
					UseContainerItem(myBags, bagSlots)
					PickupMerchantItem()
				end
			end
		end
	end
	if totalPrice ~= 0 then
		DEFAULT_CHAT_FRAME:AddMessage("What a bunch of junk! I guess I have no choice, best i can do for ya is "..GetCoinTextureString(totalPrice), 255, 255, 255)
	end

	if (CanMerchantRepair()) then	
		repairAllCost, canRepair = GetRepairAllCost();
		if (canRepair and repairAllCost > 0) then
			guildRepairedItems = false
			if (IsInGuild() and CanGuildBankRepair()) then
				local amount = GetGuildBankWithdrawMoney()
				local guildBankMoney = GetGuildBankMoney()
				amount = amount == -1 and guildBankMoney or min(amount, guildBankMoney)

				if (amount >= repairAllCost) then
					RepairAllItems(true);
					guildRepairedItems = true
					DEFAULT_CHAT_FRAME:AddMessage("Make sure you tell your GM thank you, the Gbank just repaired your gear for you at the cost of ", 255, 255, 255)
				end
			end
			

			if (repairAllCost <= GetMoney() and not guildRepairedItems) then
				RepairAllItems(false);
				DEFAULT_CHAT_FRAME:AddMessage("Wow more repairs? Its probably lack of skill, and now you lack "..GetCoinTextureString(repairAllCost), 255, 255, 255)
			end
		end
	end
end







SlashCmdList["READYCHECK"] = function() DoReadyCheck() end
SLASH_READYCHECK1 = '/rc'

SlashCmdList["CHECKROLE"] = function() InitiateRolePoll() end
SLASH_CHECKROLE1 = '/cr'

SlashCmdList["RELOAD"] = function() ReloadUI()  end
SLASH_RELOAD1 = '/rl'



--SlashCmdList["SETTINGS"] = function() DownloadSettings()  end
--SLASH_SETTINGS1 = '/settings'

--SlashCmdList["TGAST"] = function() TgastHandler  end
--SLASH_TGAST1 = '/tg'

--SlashCmdList["GVS"] = GVSHandler
--SLASH_GVS1 = "/gv"

local function GVSHandler()
LoadAddOn('Blizzard_WeeklyRewards'); WeeklyRewardsFrame:Show()
end



local function TgastHandler()
LoadAddOn('Blizzard_TorghastRewards'); TorghastLevelPickerFrame:Show()
end

hooksecurefunc("CompactUnitFrame_UpdateAll", function(frame)
    if frame:IsForbidden() or not frame:IsVisible() or not frame.buffFrames or not DefaultCompactUnitFrameSetupOptions.displayPowerBar then return end

    local barHeight = UnitGroupRolesAssigned(frame.displayedUnit) == "HEALER" and 8 or 0

    frame.healthBar:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -1, 1 + barHeight)
    frame.buffFrames[1]:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -3, CUF_AURA_BOTTOM_OFFSET + barHeight)
    frame.debuffFrames[1]:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 3, CUF_AURA_BOTTOM_OFFSET + barHeight)
end)

--Autoplace keystone

local OnShow = function()
	for Bag = 0, NUM_BAG_SLOTS do
		for Slot = 1, GetContainerNumSlots(Bag) do
			local ID = GetContainerItemID(Bag, Slot)
			
			if (ID and ID == 180653) then
				return UseContainerItem(Bag, Slot)
			end
		end
	end
end

local OnEvent = function(self, event, addon)
	if (addon == "Blizzard_ChallengesUI") then
		if ChallengesKeystoneFrame then
			ChallengesKeystoneFrame:HookScript("OnShow", OnShow)
			
			self:UnregisterEvent(event)
		end
	end
end


